<?php
header("Content-Type: text/html;charset=utf-8");

class cls_Movimiento_Producto {

	private $db_mensaje = "";
	private $db_nombretabla = "movimiento_producto";
	private $db_nombrevista = "vista_movimiento_producto";
	private $db_filas = "*";
	private $origen_id = 0;
	private $origen_nombre = "";
	private $destino_id = 0;
	private $destino_nombre = "";
	private $movimiento_producto_id = 0;
	private $movimiento_id = 0;
	private $movimiento_fecha = "0000-00-00";
	private $movimiento_hora = "00:00:00";
	private $movimiento_tipo_movimiento = "";
	private $movimiento_estado_registro = "";
	private $movimiento_estado_proceso = "";
	private $almacen_id = 0;
	private $producto_id = 0;
	private $moneda_codigo = 0;
	private $moneda_simbolo = "";
	private $moneda_cambio = 1.0;
	private $igv_porcentaje = "";
	private $precio_compra = 0.00;
	private $precio_venta = 0.00;
	private $precio_minimo = 0.00;
	private $unidades = 0;
	private $fecha_vencimiento = "0000-00-00";
	private $nombre = "";
	private $imagen = "";
	private $codigo = "";
	private $codigo_barras = "";
	private $codigo_almacen = "";
	private $fabricante = "";
	private $modelo = "";
	private $serie = "";
	private $peso = "";
	private $stock_minimo = "";
	private $categoria_id = "";
	private $categoria_codigo = "";
	private $categoria_nombre = "";
	private $unidad_medida_id = "";
	private $unidad_medida_nombre = "";
	private $unidad_medida_simbolo = "";
	private $usuario_modificacion = 0;
	private $fecha_creacion = "";
	private $fecha_modificacion = "";
	private $activo = true;
	
	public function __construct(){
		$this->db_filas = "movimiento_producto_id, origen_id, origen_nombre, destino_id, destino_nombre, movimiento_id, movimiento_fecha, movimiento_hora, movimiento_tipo_movimiento, movimiento_estado_registro, movimiento_estado_proceso, almacen_id, producto_id, moneda_codigo, moneda_simbolo, moneda_cambio, igv_porcentaje, precio_compra, precio_venta, precio_minimo, unidades, fecha_vencimiento, nombre, imagen, codigo, codigo_barras, codigo_almacen, fabricante, modelo, serie, peso, stock_minimo, categoria_id, categoria_codigo, categoria_nombre, unidad_medida_id, unidad_medida_nombre, unidad_medida_simbolo, usuario_modificacion, fecha_creacion, fecha_modificacion, activo";
	}

	static public function Indice($codigo){
		$current = new cls_Movimiento_Producto();
		$conn = new cls_Conexion();
		$filtro = "movimiento_producto_id = ?";
		$values = array();
		array_push($values, $codigo );
		$lista = $conn->buscar_datos($current->db_nombrevista, $current->db_filas, $filtro, $values, "");
		$current->db_mensaje = $conn->getMensaje();
		for ($indice=0; $indice<count($lista); $indice++){
			$current->movimiento_producto_id = $lista[$indice]["movimiento_producto_id"];
			$current->origen_id = $lista[$indice]["origen_id"];
			$current->origen_nombre = $lista[$indice]["origen_nombre"];
			$current->destino_id = $lista[$indice]["destino_id"];
			$current->destino_nombre = $lista[$indice]["destino_nombre"];
			$current->movimiento_id = $lista[$indice]["movimiento_id"];
			$current->movimiento_fecha = $lista[$indice]["movimiento_fecha"];
			$current->movimiento_hora = $lista[$indice]["movimiento_hora"];
			$current->movimiento_tipo_movimiento = $lista[$indice]["movimiento_tipo_movimiento"];
			$current->movimiento_estado_registro = $lista[$indice]["movimiento_estado_registro"];
			$current->movimiento_estado_proceso = $lista[$indice]["movimiento_estado_proceso"];
			$current->almacen_id = $lista[$indice]["almacen_id"];
			$current->producto_id = $lista[$indice]["producto_id"];
			$current->moneda_codigo = $lista[$indice]["moneda_codigo"];
			$current->moneda_simbolo = $lista[$indice]["moneda_simbolo"];
			$current->moneda_cambio = $lista[$indice]["moneda_cambio"];
			$current->igv_porcentaje = $lista[$indice]["igv_porcentaje"];
			$current->precio_compra = $lista[$indice]["precio_compra"];
			$current->precio_venta = $lista[$indice]["precio_venta"];
			$current->precio_minimo = $lista[$indice]["precio_minimo"];
			$current->unidades = $lista[$indice]["unidades"];
			$current->fecha_vencimiento = $lista[$indice]["fecha_vencimiento"];
			
			$current->nombre = $lista[$indice]["nombre"];
			$current->imagen = $lista[$indice]["imagen"];
			$current->codigo = $lista[$indice]["codigo"];;
			$current->codigo_barras = $lista[$indice]["codigo_barras"];
			$current->codigo_almacen = $lista[$indice]["codigo_almacen"];
			$current->fabricante = $lista[$indice]["fabricante"];
			$current->modelo = $lista[$indice]["modelo"];
			$current->serie = $lista[$indice]["serie"];
			$current->peso = $lista[$indice]["peso"];
			$current->stock_minimo = $lista[$indice]["stock_minimo"];
			$current->categoria_id = $lista[$indice]["categoria_id"];
			$current->categoria_codigo = $lista[$indice]["categoria_codigo"];
			$current->categoria_nombre = $lista[$indice]["categoria_nombre"];
			$current->unidad_medida_id = $lista[$indice]["unidad_medida_id"];
			$current->unidad_medida_nombre = $lista[$indice]["unidad_medida_nombre"];
			$current->unidad_medida_simbolo = $lista[$indice]["unidad_medida_simbolo"];
			
			$current->usuario_modificacion = $lista[$indice]["usuario_modificacion"];
			$current->fecha_creacion = $lista[$indice]["fecha_creacion"];
			$current->fecha_modificacion = $lista[$indice]["fecha_modificacion"];
			$current->activo = $lista[$indice]["activo"];
		}
		return $current;
	}

	public function get_movimiento_producto_id() { return $this->movimiento_producto_id; }
	public function get_movimiento_id() { return $this->movimiento_id; }
	public function get_movimiento_fecha() { return $this->movimiento_fecha; }
	public function get_movimiento_hora() { return $this->movimiento_hora; }
	public function get_movimiento_tipo_movimiento() { return $this->movimiento_tipo_movimiento; }
	public function get_movimiento_estado_registro() { return $this->movimiento_estado_registro; }
	public function get_movimiento_estado_proceso() { return $this->movimiento_estado_proceso; }
	public function get_origen_id() { return $this->origen_id; }
	public function get_origen_nombre() { return $this->origen_nombre; }
	public function get_destino_id() { return $this->destino_id; }
	public function get_destino_nombre() { return $this->destino_nombre; }
	public function get_almacen_id() { return $this->almacen_id; }
	public function get_producto_id() { return $this->producto_id; }
	public function get_moneda_codigo() { return $this->moneda_codigo; }
	public function get_moneda_simbolo() { return $this->moneda_simbolo; }
	public function get_moneda_cambio() { return $this->moneda_cambio; }
	public function get_igv_porcentaje() { return $this->igv_porcentaje; }
	public function get_precio_compra() { return $this->precio_compra; }
	public function get_precio_venta() { return $this->precio_venta; }
	public function get_precio_minimo() { return $this->precio_minimo; }
	public function get_unidades() { return $this->unidades; }
	public function get_fecha_vencimiento() { return $this->fecha_vencimiento; }
	public function get_nombre() { return $this->nombre; }
	public function get_imagen() { return $this->imagen; }
	public function get_codigo() { return $this->codigo; }
	public function get_codigo_barras() { return $this->codigo_barras; }
	public function get_codigo_almacen() { return $this->codigo_almacen; }
	public function get_fabricante() { return $this->fabricante; }
	public function get_modelo() { return $this->modelo; }
	public function get_serie() { return $this->serie; }
	public function get_peso() { return $this->peso; }
	public function get_stock_minimo() { return $this->stock_minimo; }
	public function get_categoria_id() { return $this->categoria_id; }
	public function get_categoria_codigo() { return $this->categoria_codigo; }
	public function get_categoria_nombre() { return $this->categoria_nombre; }
	public function get_unidad_medida_id() { return $this->unidad_medida_id; }
	public function get_unidad_medida_nombre() { return $this->unidad_medida_nombre; }
	public function get_unidad_medida_simbolo() { return $this->unidad_medida_simbolo; }
	public function get_usuario_modificacion(){  return $this->usuario_modificacion; }
	public function get_fecha_creacion(){  return $this->fecha_creacion; }
	public function get_fecha_modificacion(){  return $this->fecha_modificacion; }
	public function get_activo() { return $this->activo; }
	
	public function set_movimiento_producto_id($movimiento_producto_id){ $this->movimiento_producto_id = $movimiento_producto_id; }
	public function set_movimiento_id($movimiento_id){ $this->movimiento_id = $movimiento_id; }
	public function set_almacen_id($almacen_id){ $this->almacen_id = $almacen_id; }
	public function set_producto_id($producto_id){ $this->producto_id = $producto_id; }
	public function set_moneda_codigo($moneda_codigo){ $this->moneda_codigo = $moneda_codigo; }
	public function set_igv_porcentaje($igv_porcentaje){ $this->igv_porcentaje = $igv_porcentaje; }
	public function set_precio_compra($precio_compra){ $this->precio_compra = $precio_compra; }
	public function set_precio_venta($precio_venta){ $this->precio_venta = $precio_venta; }
	public function set_precio_minimo($precio_minimo){ $this->precio_minimo = $precio_minimo; }
	public function set_unidades($unidades){ $this->unidades = $unidades; }
	public function set_fecha_vencimiento($fecha_vencimiento){ $this->fecha_vencimiento = $fecha_vencimiento; }
	public function set_usuario_modificacion($usuario_modificacion){ $this->usuario_modificacion = $usuario_modificacion; }
	public function set_fecha_creacion($fecha_creacion){ $this->fecha_creacion = $fecha_creacion; }
	public function set_fecha_modificacion($fecha_modificacion){ $this->fecha_modificacion = $fecha_modificacion; }
	public function set_activo($activo){ $this->activo = $activo; }
	
	public function registrar( $usuario_editor ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
		if ( $this->movimiento_producto_id == 0 ){ // REGISTER
			array_push($values, $this->movimiento_id);
			array_push($values, $this->almacen_id);
			array_push($values, $this->producto_id);
			array_push($values, $this->moneda_codigo);
			array_push($values, $this->igv_porcentaje);
			array_push($values, $this->precio_compra);
			array_push($values, $this->precio_venta);
			array_push($values, $this->precio_minimo);
			array_push($values, $this->unidades);
			array_push($values, $this->fecha_vencimiento);
			array_push($values, $usuario_editor);
			$respuesta = $conn->nuevo_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
			if ( $respuesta ){
				$this->movimiento_producto_id = $conn->getlastId();
			}
		} else { // UPDATE
			array_push($values, $this->movimiento_id);
			array_push($values, $this->almacen_id);
			array_push($values, $this->producto_id);
			array_push($values, $this->moneda_codigo);
			array_push($values, $this->igv_porcentaje);
			array_push($values, $this->precio_compra);
			array_push($values, $this->precio_venta);
			array_push($values, $this->precio_minimo);
			array_push($values, $this->unidades);
			array_push($values, $this->fecha_vencimiento);
			array_push($values, $usuario_editor);
			array_push($values, $this->movimiento_producto_id);
			$respuesta = $conn->editar_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
		}
		return $respuesta;
	}
	
	public function importar( $usuario_editor ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
			array_push($values, $this->movimiento_producto_id);
			array_push($values, $this->movimiento_id);
			array_push($values, $this->almacen_id);
			array_push($values, $this->producto_id);
			array_push($values, $this->moneda_codigo);
			array_push($values, $this->igv_porcentaje);
			array_push($values, $this->precio_compra);
			array_push($values, $this->precio_venta);
			array_push($values, $this->precio_minimo);
			array_push($values, $this->unidades);
			array_push($values, $this->fecha_vencimiento);
			array_push($values, $this->usuario_modificacion);
			array_push($values, $this->fecha_creacion);
			array_push($values, $this->fecha_modificacion);
			array_push($values, $this->activo);
			
			array_push($values, $this->movimiento_id);
			array_push($values, $this->almacen_id);
			array_push($values, $this->producto_id);
			array_push($values, $this->moneda_codigo);
			array_push($values, $this->igv_porcentaje);
			array_push($values, $this->precio_compra);
			array_push($values, $this->precio_venta);
			array_push($values, $this->precio_minimo);
			array_push($values, $this->unidades);
			array_push($values, $this->fecha_vencimiento);
			array_push($values, $this->usuario_modificacion);
			array_push($values, $this->fecha_creacion);
			array_push($values, $this->fecha_modificacion);
			array_push($values, $this->activo);
		$respuesta = $conn->importar_registro($this->db_nombretabla, $values);
		$this->db_mensaje = $conn->GetMensaje();
		if ( $respuesta ){
			$this->movimiento_producto_id = $conn->getlastId();
		};
		return $respuesta;
	}

	public function eliminar( $usuario_editor ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
		if ($this->movimiento_producto_id > 0){ // DELETE
			array_push($values, $usuario_editor);
			array_push($values, $this->movimiento_producto_id );
			$respuesta = $conn->eliminar_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
		} else {
			$this->db_mensaje = "No se puede realizar este proceso";
		}
		return $respuesta;
	}
}

class cls_Group_Movimiento_Producto {

	protected $db_mensaje = "";
	protected $db_nombre_tabla = "vista_movimiento_producto";
	protected $db_nombres_columnas = "*";
	protected $db_filtro = "1";
	protected $db_agrupar = "";
	protected $db_orden_columna = "nombre";
	protected $db_orden_direccion = "ASC";
	protected $db_cantidad = 0;
	protected $db_filtro_datos = array();
	protected $db_filas = array();
	
	public function __construct(){
		$this->db_nombres_columnas = "movimiento_producto_id, origen_id, origen_nombre, destino_id, destino_nombre, movimiento_id, movimiento_fecha, movimiento_hora, movimiento_tipo_movimiento, movimiento_estado_registro, movimiento_estado_proceso, almacen_id, producto_id, moneda_codigo, moneda_simbolo, moneda_cambio, igv_porcentaje, precio_compra, precio_venta, precio_minimo, unidades, fecha_vencimiento, nombre, imagen, codigo, codigo_barras, codigo_almacen, fabricante, modelo, serie, peso, stock_minimo, categoria_id, categoria_codigo, categoria_nombre, unidad_medida_id, unidad_medida_nombre, unidad_medida_simbolo, usuario_modificacion, fecha_creacion, fecha_modificacion, activo";
		$this->db_orden_columna = "movimiento_producto_id";
	}

	static public function Export($fecha_min, $fecha_max, $ordendireccion="ASC", $ordencolumna="movimiento_producto_id", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Movimiento_Producto();
		$current->db_filtro = "DATE(fecha_creacion) > DATE(?) AND DATE(fecha_creacion) <= DATE(?)";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		array_push($current->db_filtro_datos, $fecha_min);
		array_push($current->db_filtro_datos, $fecha_max);
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	static public function Movimiento($movimiento=0, $ordendireccion="ASC", $ordencolumna="movimiento_fecha, movimiento_hora", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Movimiento_Producto();
		$current->db_filtro = "movimiento_id = ? AND activo = true";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		array_push($current->db_filtro_datos, $movimiento );
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	static public function TiendaFecha($tienda, $fecha_min, $fecha_max, $ordendireccion="DESC", $ordencolumna="movimiento_fecha, movimiento_hora", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Movimiento_Producto();
		$current->db_filtro = "destino_id = ? AND DATE(movimiento_fecha) >= DATE(?) AND DATE(movimiento_fecha) <= DATE(?) AND activo = true";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		array_push($current->db_filtro_datos, $tienda );
		array_push($current->db_filtro_datos, $fecha_min );
		array_push($current->db_filtro_datos, $fecha_max );
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	static public function IngresoTiendaFecha($tienda, $buscar, $fecha_min, $fecha_max, $ordendireccion="DESC", $ordencolumna="movimiento_fecha", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Movimiento_Producto();
		$l_buscar = explode(" ", $buscar);
		$current->db_filtro = "";
		for ($idx=0; $idx<count($l_buscar); $idx++){
			array_push($current->db_filtro_datos, "%".$l_buscar[$idx]."%" );
			$current->db_filtro .= "CONCAT(codigo, ' ', nombre, ' ', nombre_alternativo) LIKE ? AND ";
		}
		array_push($current->db_filtro_datos, $tienda );
		array_push($current->db_filtro_datos, $fecha_min );
		array_push($current->db_filtro_datos, $fecha_max );
		$current->db_filtro .= "destino_id = ? AND DATE(movimiento_fecha) >= DATE(?) AND DATE(movimiento_fecha) <= DATE(?) AND activo = true";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	static public function SalidaTiendaFecha($tienda, $buscar, $fecha_min, $fecha_max, $ordendireccion="DESC", $ordencolumna="movimiento_fecha", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Movimiento_Producto();
		$l_buscar = explode(" ", $buscar);
		$current->db_filtro = "";
		for ($idx=0; $idx<count($l_buscar); $idx++){
			array_push($current->db_filtro_datos, "%".$l_buscar[$idx]."%" );
			$current->db_filtro .= "CONCAT(codigo, ' ', nombre, ' ', nombre_alternativo) LIKE ? AND ";
		}
		array_push($current->db_filtro_datos, $tienda );
		array_push($current->db_filtro_datos, $fecha_min );
		array_push($current->db_filtro_datos, $fecha_max );
		$current->db_filtro .= "origen_id = ? AND DATE(movimiento_fecha) >= DATE(?) AND DATE(movimiento_fecha) <= DATE(?) AND activo = true";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	static public function TiendaFechaEstado($tienda, $fecha_min, $fecha_max, $estado, $ordendireccion="ASC", $ordencolumna="movimiento_fecha, movimiento_hora", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Movimiento_Producto();
		$current->db_filtro = "destino_id = ? AND DATE(movimiento_fecha) >= DATE(?) AND DATE(movimiento_fecha) <= DATE(?) AND (movimiento_estado_registro LIKE ? OR ? LIKE 'Todos') AND activo = true";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		array_push($current->db_filtro_datos, $tienda );
		array_push($current->db_filtro_datos, $fecha_min );
		array_push($current->db_filtro_datos, $fecha_max );
		array_push($current->db_filtro_datos, $estado );
		array_push($current->db_filtro_datos, $estado );
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	public function cargar_datos( $offset, $cantidad ){
		$conn = new cls_Conexion();
		$this->db_filas = $conn->listar_filas( $this->db_nombre_tabla, $this->db_nombres_columnas, $this->db_orden_columna, $this->db_orden_direccion, $this->db_filtro, $this->db_filtro_datos, $offset, $cantidad, $this->db_agrupar );
		$this->db_mensaje = $conn->GetMensaje();
	}
	public function get_cantidad_cargados(){
		return count($this->db_filas);
	}
	public function get_cantidad(){
		return $this->db_cantidad;
	}
	
	public function get_movimiento_producto_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["movimiento_producto_id"];
			return $val;
		}
		return 0;
	}
	public function get_origen_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["origen_id"];
			return $val;
		}
		return 0;
	}
	public function get_origen_nombre($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["origen_nombre"];
			return $val;
		}
		return "";
	}
	public function get_destino_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["destino_id"];
			return $val;
		}
		return 0;
	}
	public function get_destino_nombre($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["destino_nombre"];
			return $val;
		}
		return "";
	}
	public function get_movimiento_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["movimiento_id"];
			return $val;
		}
		return "";
	}
	public function get_movimiento_fecha($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["movimiento_fecha"];
			return $val;
		}
		return "";
	}
	public function get_movimiento_hora($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["movimiento_hora"];
			return $val;
		}
		return "";
	}
	public function get_movimiento_tipo_movimiento($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["movimiento_tipo_movimiento"];
			return $val;
		}
		return "";
	}
	public function get_movimiento_estado_registro($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["movimiento_estado_registro"];
			return $val;
		}
		return "";
	}
	public function get_movimiento_estado_proceso($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["movimiento_estado_proceso"];
			return $val;
		}
		return "";
	}
	public function get_almacen_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["almacen_id"];
			return $val;
		}
		return "";
	}
	public function get_producto_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["producto_id"];
			return $val;
		}
		return "";
	}
	public function get_moneda_codigo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["moneda_codigo"];
			return $val;
		}
		return "";
	}
	public function get_moneda_simbolo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["moneda_simbolo"];
			return $val;
		}
		return "";
	}
	public function get_moneda_cambio($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["moneda_cambio"];
			return $val;
		}
		return "";
	}
	public function get_igv_porcentaje($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["igv_porcentaje"];
			return $val;
		}
		return "";
	}
	public function get_precio_compra($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["precio_compra"];
			return $val;
		}
		return "";
	}
	public function get_precio_venta($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["precio_venta"];
			return $val;
		}
		return "";
	}
	public function get_precio_minimo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["precio_minimo"];
			return $val;
		}
		return "";
	}
	public function get_unidades($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["unidades"];
			return $val;
		}
		return "";
	}
	public function get_fecha_vencimiento($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["fecha_vencimiento"];
			return $val;
		}
		return "";
	}
	public function get_nombre($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["nombre"];
			return $val;
		}
		return "";
	}
	public function get_imagen($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["imagen"];
			return $val;
		}
		return "";
	}
	public function get_codigo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["codigo"];
			return $val;
		}
		return "";
	}
	public function get_codigo_barras($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["codigo_barras"];
			return $val;
		}
		return "";
	}
	public function get_codigo_almacen($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["codigo_almacen"];
			return $val;
		}
		return "";
	}
	public function get_fabricante($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["fabricante"];
			return $val;
		}
		return "";
	}
	public function get_modelo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["modelo"];
			return $val;
		}
		return "";
	}
	public function get_serie($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["serie"];
			return $val;
		}
		return "";
	}
	public function get_peso($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["peso"];
			return $val;
		}
		return "";
	}
	public function get_stock_minimo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["stock_minimo"];
			return $val;
		}
		return "";
	}
	public function get_categoria_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["categoria_id"];
			return $val;
		}
		return "";
	}
	public function get_categoria_codigo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["categoria_codigo"];
			return $val;
		}
		return "";
	}
	public function get_categoria_nombre($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["categoria_nombre"];
			return $val;
		}
		return "";
	}
	public function get_unidad_medida_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["unidad_medida_id"];
			return $val;
		}
		return "";
	}
	public function get_unidad_medida_nombre($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["unidad_medida_nombre"];
			return $val;
		}
		return "";
	}
	public function get_unidad_medida_simbolo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["unidad_medida_simbolo"];
			return $val;
		}
		return "";
	}
	public function get_usuario_modificacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["usuario_modificacion"];
			return $val;
		}
		return 0;
	}
	public function get_fecha_creacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["fecha_creacion"];
			return $val;
		}
		return "";
	}
	public function get_fecha_modificacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["fecha_modificacion"];
			return $val;
		}
		return "";
	}
	public function get_activo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["activo"];
			return $val;
		}
		return "";
	}
};
?>		
